#ifndef SIMON_H
#define SIMON_H

#ifndef CIPHER_CONSTANTS
#define CIPHER_CONSTANTS


#endif

enum simon_cipher_config_t {
	Simon_256_128
};

typedef struct {

	uint16_t key_size;
	uint8_t block_size;
	uint8_t round_limit;
	uint8_t init_vector[16];
	uint8_t counter[16];
	uint8_t key_schedule[576];
	uint8_t z_seq;
} Simon_Cipher;

typedef struct _bword_24 {
	uint32_t data : 24;
} bword_24;

typedef struct _bword_48 {
	uint64_t data : 48;
} bword_48;

uint8_t Simon_Init(Simon_Cipher *cipher_object, void *key);

uint8_t Simon_Encrypt(Simon_Cipher cipher_object, const void *plaintext,
	void *ciphertext);

void Simon_Encrypt_128(const uint8_t round_limit, const void *key_schedule,
 uint8_t *plaintext);

void Simon_Decrypt_128(const uint8_t round_limit, const void *key_schedule,
	uint8_t *ciphertext);

#endif
