/*

Simon cipher

WEB: amsoftware.narod.ru
E-Mail: amsoftware@ya.ru

*/

#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <simon.h>


typedef unsigned char u8;
typedef unsigned long u32;
typedef unsigned short u16;

Simon_Cipher my_simon_cipher;

void __stdcall __export setup(u8 * usrkey) {

Simon_Init(&my_simon_cipher, usrkey);

}

void __stdcall __export crypt(u8 * data) {
	Simon_Encrypt_128(my_simon_cipher.round_limit,
		&my_simon_cipher.key_schedule, data);
}

void __stdcall __export decrypt(u8 * data) {
	Simon_Decrypt_128(my_simon_cipher.round_limit,
		&my_simon_cipher.key_schedule, data);
}

u32 __stdcall __export getblocksize() {
	return 128;
}

u32 __stdcall __export getkeysize() {
	return 256;
}

void __stdcall __export getciphername(unsigned char *p) {
	strcpy(p, "Simon128/256");
}
